/** ADMIN CUSOMIZATION
 * Purpose of this file is to contain customisation elements of admin
 * 
 */

//launch functions on domloaded
document.addEventListener('DOMContentLoaded', (event) => {
    // console.log("launching functions");
    globalTargettingFieldVisibility()
    targettingFunctionFieldVisibility()
    targettingPlatformFieldVisibility()
})

/**
 * Hide all fieldsets that are not selected
 * ex: Use choses "target by Postal Code"
 * Hide "specific targetting" options
 */

function globalTargettingFieldVisibility() {
    //get the dropdown that allows user to select
    let targettingMethodDropdown = document.querySelector("div[class='form-row field-typeOfTargetting'] select")
    const sectionspecificRepresentatives = document.querySelector("div[class='form-row field-specificTargetedRepresentatives']").parentElement
    const sectionChooseTargetedFunction = document.querySelector("div[class='form-row field-targetedOfficials']")
    const sectionChoosePlatforms = document.querySelector("div[class='form-row field-contactPlateforms']")
    const sectionDeputee = document.querySelector("div[class='form-row field-electedofficialEmailSubject']").parentElement
    const sectionSenateur = document.querySelector("div[class='form-row field-senatorEmailSubject']").parentElement
    const sectionCandidat = document.querySelector("div[class='form-row field-candidateEmailSubject']").parentElement

    targettingMethod = targettingMethodDropdown.value
    console.log("initial targeting methode", targettingMethod);
    updateDisplay(targettingMethod)

    targettingMethodDropdown.addEventListener("change", function () {
        targettingMethod = targettingMethodDropdown.value
        console.log("dropdown change", targettingMethod);
        updateDisplay(targettingMethod)
    });

    function updateDisplay(targettingMethod) {
        switch (targettingMethod) {
            case 'postalCode':
                sectionspecificRepresentatives.style.display = 'none'
                sectionChooseTargetedFunction.style.display = 'block'
                sectionChoosePlatforms.style.display = 'block'
                sectionDeputee.style.display = 'block'
                sectionSenateur.style.display = 'block'
                sectionCandidat.style.display = 'block'
                break;
            case 'specificRepresentatives':
                sectionspecificRepresentatives.style.display = 'block'
                sectionChooseTargetedFunction.style.display = 'none'
                sectionChoosePlatforms.style.display = 'block'
                sectionDeputee.style.display = 'none'
                sectionSenateur.style.display = 'none'
                sectionCandidat.style.display = 'none'
                break;
            //fill in once feature is available
            case 'byGeography':
                window.alert("Cette option n'est pas encore fonctionnelle")
                break;

            case 'none':
                sectionspecificRepresentatives.style.display = 'none'
                sectionChooseTargetedFunction.style.display = 'none'
                sectionChoosePlatforms.style.display = 'none'
                sectionDeputee.style.display = 'none'
                sectionSenateur.style.display = 'none'
                sectionCandidat.style.display = 'none'
                break;
            default:
                sectionspecificRepresentatives.style.display = 'block'
                sectionChooseTargetedFunction.style.display = 'block'
                sectionChoosePlatforms.style.display = 'block'
                sectionDeputee.style.display = 'block'
                sectionSenateur.style.display = 'block'
                sectionCandidat.style.display = 'block'
                break;
        }
    }
}

/**
 * Hide fieldsets of functions not used
 */
function targettingFunctionFieldVisibility() {
    let targettingFunctionDropdown = document.querySelector("div[class='form-row field-targetedOfficials'] select")
    allOptions = targettingFunctionDropdown.options

    displayChosenOptions(allOptions)
    targettingFunctionDropdown.addEventListener("change", function () {
        // console.log("function dropdown change", allOptions);
        displayChosenOptions(allOptions)
    });
    function displayChosenOptions(allOptions) {
        selectedOptions = []
        for (let i = 0; i < allOptions.length; i++) {
            console.log(allOptions[i], allOptions[i].selected);
            if (allOptions[i].selected == true) {
                selectedOptions.push(allOptions[i].innerText)
            }
        }
        // console.log("updated selected options", selectedOptions)
        const sectionDeputee = document.querySelector("div[class='form-row field-electedofficialEmailSubject']").parentElement
        const sectionSenateur = document.querySelector("div[class='form-row field-senatorEmailSubject']").parentElement
        const sectionCandidat = document.querySelector("div[class='form-row field-candidateEmailSubject']").parentElement
        
        //display all options before hidding ones that are not in choice
        sectionDeputee.style.display = 'block'
        sectionSenateur.style.display = 'block'
        sectionCandidat.style.display = 'block'

        //hide options that are not in choices
        if (!selectedOptions.includes('Député•e')) {
            sectionDeputee.style.display = 'none'
        }
        if (!selectedOptions.includes('Sénateur•ice')) {
            sectionSenateur.style.display = 'none'
        }
        if (!selectedOptions.includes('Candidat•e•s')) {
            sectionCandidat.style.display = 'none'
        }
    }
}


/**
 * Hide fieldsets of platforms not targetted
 */
function targettingPlatformFieldVisibility(){
    let targettingPlatformDropdown = document.querySelector("div[class='form-row field-contactPlateforms'] select")
    allPlatforms = targettingPlatformDropdown.options
    displayChosenOptions(allPlatforms)
    targettingPlatformDropdown.addEventListener("change", function () {
        // console.log("platform dropdown change", allPlatforms);
        displayChosenOptions(allPlatforms)
    });
    function displayChosenOptions(allPlatforms) {
        selectedPlatforms = []
        for (let i = 0; i < allPlatforms.length; i++) {
            console.log(allPlatforms[i], allPlatforms[i].selected);
            if (allPlatforms[i].selected == true) {
                selectedPlatforms.push(allPlatforms[i].innerText)
            }
        }
        // console.log("selected platforms are",selectedPlatforms);
        //before hiding unselected elements, display all fields
        showHideAllFieldsWithTerm("EmailSubject","block")
        showHideAllFieldsWithTerm("EmailText","block")
        showHideAllFieldsWithTerm("Tweet","block")
        showHideAllFieldsWithTerm("CallObjective","block")
        showHideAllFieldsWithTerm("CallArgumentation","block")

         //hide options that are not in choices
         if (!selectedPlatforms.includes('Par Email')) {
            showHideAllFieldsWithTerm("EmailSubject","none")
            showHideAllFieldsWithTerm("EmailText","none")
        }
        if (!selectedPlatforms.includes('Sur Twitter')) {
            showHideAllFieldsWithTerm("Tweet","none")
        }
        if (!selectedPlatforms.includes('Par téléphone')) {
            showHideAllFieldsWithTerm("CallObjective","none")
            showHideAllFieldsWithTerm("CallArgumentation","none")
        } 
    }
}


function showHideAllFieldsWithTerm(term,displayValue) {
    let fieldsToHide = document.querySelectorAll("div[class*='"+term+"'")
    console.log(displayValue,"fields",fieldsToHide);
    fieldsToHide.forEach(field => {
        field.style.display = displayValue;
    });
}